-- SPDX-FileCopyrightText: 2021 Oxhead Alpha
-- SPDX-License-Identifier: LicenseRef-MIT-OA

-- | Tests on ordering of documentation items.
module Test.Lorentz.Doc.Positions
  ( test_Errors
  ) where

import Test.Tasty (TestTree)
import Test.Tasty.HUnit (testCase)

import Lorentz.Errors
import Lorentz.Errors.Numeric
import Test.Cleveland.Util (assertGoesBefore)

test_Errors :: [TestTree]
test_Errors =
  [ testCase "Error tag mapping is described before errors" $
      -- This is required because when @Errors@ section is modified
      -- to mention numeric error tags, it needs some clarification
      -- provided by @About error tag mapping@ section.
      Proxy @DDescribeErrorTagMap `assertGoesBefore` Proxy @DError
  ]
